#ifndef _PG_MPI_TRAITS_
#define _PG_MPI_TRAITS_

#include "mpi.h"

namespace ParGraph
{
template< class A >
struct mpi_traits
{
};

template<>
struct mpi_traits<int>
{
  const MPI_Datatype mpi_type;
  mpi_traits() : mpi_type(MPI_INT) {}
  // static const MPI_Datatype mpi_type = MPI_INT;
};

template<>
struct mpi_traits<unsigned int>
{
  const MPI_Datatype mpi_type;
  mpi_traits() : mpi_type(MPI_UNSIGNED) {}
  //static const MPI_Datatype mpi_type = MPI_UNSIGNED;
};

template<>
struct mpi_traits<const unsigned int>
{
  const MPI_Datatype mpi_type;
  mpi_traits() : mpi_type(MPI_UNSIGNED) {}
  // static const MPI_Datatype mpi_type = MPI_UNSIGNED;
};

template<>
struct mpi_traits<short int>
{
  const MPI_Datatype mpi_type;
  mpi_traits() : mpi_type(MPI_SHORT) {}
  // static const MPI_Datatype mpi_type = MPI_SHORT;
};

template<>
struct mpi_traits<char>
{
  const MPI_Datatype mpi_type;
  mpi_traits() : mpi_type(MPI_CHAR) {}
  // static const MPI_Datatype mpi_type = MPI_CHAR;
};

}
#endif
